import router from './router'
import store from './store'
import { Message } from 'element-ui'
import NProgress from 'nprogress'
import 'nprogress/nprogress.css'
import { getAccessToken } from '@/utils/auth'
import { isRelogin } from '@/utils/request'

NProgress.configure({ showSpinner: false })
// const menus = [
//     {
//         "id": 1,
//         "parentId": 0,
//         "name": "任务管理",
//         "path": "/task",
//         "component": null,
//         "componentName": null,
//         "icon": "cascader",
//         "visible": true,
//         "keepAlive": true,
//         "alwaysShow": true,
//         "children": [
//             {
//                 "id": 1201,
//                 "parentId": 1200,
//                 "name": "我的流程",
//                 "path": "my",
//                 "component": "bpm/processInstance/index",
//                 "componentName": "BpmProcessInstance",
//                 "icon": "people",
//                 "visible": true,
//                 "keepAlive": true,
//                 "alwaysShow": true,
//                 "children": null
//             },
//             {
//                 "id": 1207,
//                 "parentId": 1200,
//                 "name": "待办任务",
//                 "path": "todo",
//                 "component": "bpm/task/todo/index",
//                 "componentName": "BpmTodoTask",
//                 "icon": "eye-open",
//                 "visible": true,
//                 "keepAlive": true,
//                 "alwaysShow": true,
//                 "children": null
//             },
//             {
//                 "id": 1208,
//                 "parentId": 1200,
//                 "name": "已办任务",
//                 "path": "done",
//                 "component": "bpm/task/done/index",
//                 "componentName": "BpmDoneTask",
//                 "icon": "eye",
//                 "visible": true,
//                 "keepAlive": true,
//                 "alwaysShow": true,
//                 "children": null
//             }
//         ]
//     }
// ]

// 增加三方登陆 update by 芋艿
const whiteList = ['/login','/register','/password/forget','/password/reset','/social-login',  '/auth-redirect', '/bind',  '/oauthLogin/gitee']

router.beforeEach((to, from, next) => {
  NProgress.start()
  if (getAccessToken()) {
    to.meta.title && store.dispatch('settings/setTitle', to.meta.title)
    /* has token*/
    if (to.path === '/login') {
      next({ path: '/' })
      NProgress.done()
    } else {
      if (store.getters.roles.length === 0) {
        isRelogin.show = true
        // 获取字典数据 add by 芋艿
        store.dispatch('dict/loadDictDatas')
        // 判断当前用户是否已拉取完 user_info 信息
        store.dispatch('GetInfo').then(userInfo => {
          console.log('用户信息',userInfo);
          isRelogin.show = false
          if(localStorage.getItem('new')){
            var path = localStorage.getItem('new')
            if (path == to.path) { //动态路由页面的刷新事件
              //触发 GenerateRoutes 事件时，将 menus 菜单树传递进去
              //获取菜单数据
              let menus = localStorage.getItem('menus')
              store.dispatch('GenerateRoutes', JSON.parse(menus)).then(accessRoutes => {
                // 根据 roles 权限生成可访问的路由表
                router.addRoutes(accessRoutes) // 动态添加可访问路由表
                next({ ...to, replace: true }) // hack方法 确保addRoutes已完成
              })
            }
          }
          next({ ...to, replace: true }) 
        }).catch(err => {
          store.dispatch('LogOut').then(() => {
            Message.error(err)
            next({ path: '/' })
          })
        })
      } else {
        next()
      }
    }
  } else {
    // 没有token
    if (whiteList.indexOf(to.path) !== -1) {
      // 在免登录白名单，直接进入
      next()
    } else {
      const redirect = encodeURIComponent(to.fullPath) // 编码 URI，保证参数跳转回去后，可以继续带上
      next(`/login?redirect=${redirect}`) // 否则全部重定向到登录页
      NProgress.done()
    }
  }
})

router.afterEach((to, from) => {
  localStorage.setItem("new",to.path)
  NProgress.done()
})
